<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Material Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_material.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_material-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Material Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to create and manipulate surface materials.  
 <a href="class_material.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_material_8hpp_source.html">Material.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa798c4ee73c9078a8c5c23fee3edebae"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#aa798c4ee73c9078a8c5c23fee3edebae">Material</a> (<a class="el" href="class_vec.html">Vec</a> _cr, <a class="el" href="class_vec.html">Vec</a> _cp, <a class="el" href="class_vec.html">Vec</a> _ca, double _p, double _decay, double _rft, bool _emissive, bool _refl, bool _refr, bool _bump, const char *_filename)</td></tr>
<tr class="memdesc:aa798c4ee73c9078a8c5c23fee3edebae"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> constructor.  <a href="#aa798c4ee73c9078a8c5c23fee3edebae">More...</a><br /></td></tr>
<tr class="separator:aa798c4ee73c9078a8c5c23fee3edebae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a137e987401b63eb7c6c27c3e38bc74b5"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a137e987401b63eb7c6c27c3e38bc74b5">Material</a> ()</td></tr>
<tr class="separator:a137e987401b63eb7c6c27c3e38bc74b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c19452d71f54075df8f5405b03129f4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a2c19452d71f54075df8f5405b03129f4">~Material</a> ()</td></tr>
<tr class="separator:a2c19452d71f54075df8f5405b03129f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0280b01366a8f0fc2ffdeb87ac0fd275"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a0280b01366a8f0fc2ffdeb87ac0fd275">getCr</a> ()</td></tr>
<tr class="memdesc:a0280b01366a8f0fc2ffdeb87ac0fd275"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the diffuse reflectance vector for this material.  <a href="#a0280b01366a8f0fc2ffdeb87ac0fd275">More...</a><br /></td></tr>
<tr class="separator:a0280b01366a8f0fc2ffdeb87ac0fd275"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a847f683a1b2f97d6a7ee182c9e87eca3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a847f683a1b2f97d6a7ee182c9e87eca3">setCr</a> (<a class="el" href="class_vec.html">Vec</a> _cr)</td></tr>
<tr class="memdesc:a847f683a1b2f97d6a7ee182c9e87eca3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the diffuse reflectance vector for this material.  <a href="#a847f683a1b2f97d6a7ee182c9e87eca3">More...</a><br /></td></tr>
<tr class="separator:a847f683a1b2f97d6a7ee182c9e87eca3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad07aff294522f7d3c0d453627bd364fd"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#ad07aff294522f7d3c0d453627bd364fd">getCp</a> ()</td></tr>
<tr class="memdesc:ad07aff294522f7d3c0d453627bd364fd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the specular reflectance vector for this material.  <a href="#ad07aff294522f7d3c0d453627bd364fd">More...</a><br /></td></tr>
<tr class="separator:ad07aff294522f7d3c0d453627bd364fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e1ec1391572fc46164d392f07129174"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a8e1ec1391572fc46164d392f07129174">setCp</a> (<a class="el" href="class_vec.html">Vec</a> _cp)</td></tr>
<tr class="memdesc:a8e1ec1391572fc46164d392f07129174"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the specular reflectance vector for this material.  <a href="#a8e1ec1391572fc46164d392f07129174">More...</a><br /></td></tr>
<tr class="separator:a8e1ec1391572fc46164d392f07129174"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa01fadeeceee9591a552c3688db5a533"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#aa01fadeeceee9591a552c3688db5a533">getCa</a> ()</td></tr>
<tr class="memdesc:aa01fadeeceee9591a552c3688db5a533"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the ambient light vector for this material.  <a href="#aa01fadeeceee9591a552c3688db5a533">More...</a><br /></td></tr>
<tr class="separator:aa01fadeeceee9591a552c3688db5a533"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeee8f14c34749e8d299ca6e43858a840"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#aeee8f14c34749e8d299ca6e43858a840">setCa</a> (<a class="el" href="class_vec.html">Vec</a> _ca)</td></tr>
<tr class="memdesc:aeee8f14c34749e8d299ca6e43858a840"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the ambient light vector for this material.  <a href="#aeee8f14c34749e8d299ca6e43858a840">More...</a><br /></td></tr>
<tr class="separator:aeee8f14c34749e8d299ca6e43858a840"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65f9dd5151b513f5bcf54a5fd59b15f2"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a65f9dd5151b513f5bcf54a5fd59b15f2">getPhong</a> ()</td></tr>
<tr class="memdesc:a65f9dd5151b513f5bcf54a5fd59b15f2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the Phong exponent for this material.  <a href="#a65f9dd5151b513f5bcf54a5fd59b15f2">More...</a><br /></td></tr>
<tr class="separator:a65f9dd5151b513f5bcf54a5fd59b15f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a61bbfad1e60d4e41943972774d0bc067"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a61bbfad1e60d4e41943972774d0bc067">setPhong</a> (double _p)</td></tr>
<tr class="memdesc:a61bbfad1e60d4e41943972774d0bc067"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the Phong exponent for this material.  <a href="#a61bbfad1e60d4e41943972774d0bc067">More...</a><br /></td></tr>
<tr class="separator:a61bbfad1e60d4e41943972774d0bc067"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6175de849601404346db9607b44986dd"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a6175de849601404346db9607b44986dd">isEmissive</a> ()</td></tr>
<tr class="memdesc:a6175de849601404346db9607b44986dd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a boolean stating whether this is an emissive material.  <a href="#a6175de849601404346db9607b44986dd">More...</a><br /></td></tr>
<tr class="separator:a6175de849601404346db9607b44986dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a782130f7a711c6607dcfe6124a82469f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a782130f7a711c6607dcfe6124a82469f">setEmissive</a> (bool _emissive)</td></tr>
<tr class="memdesc:a782130f7a711c6607dcfe6124a82469f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a boolean stating whether this is an emissive material.  <a href="#a782130f7a711c6607dcfe6124a82469f">More...</a><br /></td></tr>
<tr class="separator:a782130f7a711c6607dcfe6124a82469f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9456e7bde8f91663bb7bae200877e45a"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a9456e7bde8f91663bb7bae200877e45a">isBumpMapped</a> ()</td></tr>
<tr class="memdesc:a9456e7bde8f91663bb7bae200877e45a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a boolean stating whether this is a bump mapped material.  <a href="#a9456e7bde8f91663bb7bae200877e45a">More...</a><br /></td></tr>
<tr class="separator:a9456e7bde8f91663bb7bae200877e45a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab1a8ca07450c105b312f501db03d9ded"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#ab1a8ca07450c105b312f501db03d9ded">setBumpMapped</a> (bool _bump)</td></tr>
<tr class="memdesc:ab1a8ca07450c105b312f501db03d9ded"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a boolean stating whether this is a bump mapped material.  <a href="#ab1a8ca07450c105b312f501db03d9ded">More...</a><br /></td></tr>
<tr class="separator:ab1a8ca07450c105b312f501db03d9ded"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f2ba344ff230ccb271f60968af8b0e1"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a6f2ba344ff230ccb271f60968af8b0e1">isTextureMapped</a> ()</td></tr>
<tr class="memdesc:a6f2ba344ff230ccb271f60968af8b0e1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a boolean stating whether this is a textured mapped material.  <a href="#a6f2ba344ff230ccb271f60968af8b0e1">More...</a><br /></td></tr>
<tr class="separator:a6f2ba344ff230ccb271f60968af8b0e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a938b386ff83eb1cde4831c0c36a5407e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a938b386ff83eb1cde4831c0c36a5407e">setTextureMapped</a> (bool _tex_map)</td></tr>
<tr class="memdesc:a938b386ff83eb1cde4831c0c36a5407e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a boolean stating whether this is a textured mapped material.  <a href="#a938b386ff83eb1cde4831c0c36a5407e">More...</a><br /></td></tr>
<tr class="separator:a938b386ff83eb1cde4831c0c36a5407e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d14399b390d6795965b51ae9f51e9f4"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a4d14399b390d6795965b51ae9f51e9f4">isReflective</a> ()</td></tr>
<tr class="memdesc:a4d14399b390d6795965b51ae9f51e9f4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a boolean stating whether this is a reflective material.  <a href="#a4d14399b390d6795965b51ae9f51e9f4">More...</a><br /></td></tr>
<tr class="separator:a4d14399b390d6795965b51ae9f51e9f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b442ea5f27bc51da4822e02fb4297bb"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a7b442ea5f27bc51da4822e02fb4297bb">setReflective</a> (bool _reflective)</td></tr>
<tr class="memdesc:a7b442ea5f27bc51da4822e02fb4297bb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a boolean stating whether this is a reflective material.  <a href="#a7b442ea5f27bc51da4822e02fb4297bb">More...</a><br /></td></tr>
<tr class="separator:a7b442ea5f27bc51da4822e02fb4297bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad7ca9400c928202eaca2082e291125b1"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#ad7ca9400c928202eaca2082e291125b1">isRefractive</a> ()</td></tr>
<tr class="memdesc:ad7ca9400c928202eaca2082e291125b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a boolean stating whether this is a refractive material.  <a href="#ad7ca9400c928202eaca2082e291125b1">More...</a><br /></td></tr>
<tr class="separator:ad7ca9400c928202eaca2082e291125b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adff5906d2e02f7191d6827f093789780"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#adff5906d2e02f7191d6827f093789780">setRefractive</a> (bool _refractive)</td></tr>
<tr class="memdesc:adff5906d2e02f7191d6827f093789780"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a boolean stating whether this is a refractive material.  <a href="#adff5906d2e02f7191d6827f093789780">More...</a><br /></td></tr>
<tr class="separator:adff5906d2e02f7191d6827f093789780"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbacd01f9d2f985ede123b91687280e8"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#acbacd01f9d2f985ede123b91687280e8">getRefractiveIndex</a> ()</td></tr>
<tr class="memdesc:acbacd01f9d2f985ede123b91687280e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the refractive index of this material.  <a href="#acbacd01f9d2f985ede123b91687280e8">More...</a><br /></td></tr>
<tr class="separator:acbacd01f9d2f985ede123b91687280e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a114906601db621c0d7101961300d8308"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a114906601db621c0d7101961300d8308">setRefractiveIndex</a> (double _rft)</td></tr>
<tr class="memdesc:a114906601db621c0d7101961300d8308"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the refractive index of this material.  <a href="#a114906601db621c0d7101961300d8308">More...</a><br /></td></tr>
<tr class="separator:a114906601db621c0d7101961300d8308"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6db84f732fc3c38423cbbec8d15e52cb"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a6db84f732fc3c38423cbbec8d15e52cb">getTilesNumber</a> ()</td></tr>
<tr class="memdesc:a6db84f732fc3c38423cbbec8d15e52cb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of times the texture is to be replicated in each direction.  <a href="#a6db84f732fc3c38423cbbec8d15e52cb">More...</a><br /></td></tr>
<tr class="separator:a6db84f732fc3c38423cbbec8d15e52cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9a0316f3ea807c95d1b3d347bfd7dc0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#ae9a0316f3ea807c95d1b3d347bfd7dc0">setTilesNumber</a> (int _tiling)</td></tr>
<tr class="memdesc:ae9a0316f3ea807c95d1b3d347bfd7dc0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the number of times the texture is to be replicated in each direction.  <a href="#ae9a0316f3ea807c95d1b3d347bfd7dc0">More...</a><br /></td></tr>
<tr class="separator:ae9a0316f3ea807c95d1b3d347bfd7dc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbbad91a1d220c635894891ab71d6563"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#abbbad91a1d220c635894891ab71d6563">getLightDecay</a> ()</td></tr>
<tr class="separator:abbbad91a1d220c635894891ab71d6563"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae52779c037c246aceac07f2d14fb92a8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#ae52779c037c246aceac07f2d14fb92a8">setLightDecay</a> (double _decay)</td></tr>
<tr class="separator:ae52779c037c246aceac07f2d14fb92a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afbe529757a43277bb1d1a65c42741e68"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#afbe529757a43277bb1d1a65c42741e68">tex_pixel</a> (<a class="el" href="class_vec.html">Vec</a> &amp;tex_coord)</td></tr>
<tr class="memdesc:afbe529757a43277bb1d1a65c42741e68"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the colour Vector obtained from the texture, given a 2D texture coordinate.  <a href="#afbe529757a43277bb1d1a65c42741e68">More...</a><br /></td></tr>
<tr class="separator:afbe529757a43277bb1d1a65c42741e68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ec5589e2e78d79fa32c25ee00a3b824"><td class="memItemLeft" align="right" valign="top">double *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a7ec5589e2e78d79fa32c25ee00a3b824">loadPPM</a> (const char *filename)</td></tr>
<tr class="memdesc:a7ec5589e2e78d79fa32c25ee00a3b824"><td class="mdescLeft">&#160;</td><td class="mdescRight">Loads a texture from a .ppm file.  <a href="#a7ec5589e2e78d79fa32c25ee00a3b824">More...</a><br /></td></tr>
<tr class="separator:a7ec5589e2e78d79fa32c25ee00a3b824"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a6b14d96290f6529241d9b898596b83c5"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a6b14d96290f6529241d9b898596b83c5">cr</a></td></tr>
<tr class="memdesc:a6b14d96290f6529241d9b898596b83c5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Diffuse reflectance vector for this material.  <a href="#a6b14d96290f6529241d9b898596b83c5">More...</a><br /></td></tr>
<tr class="separator:a6b14d96290f6529241d9b898596b83c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ea8e096eeff4452f59443d6cb9bbdd1"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a5ea8e096eeff4452f59443d6cb9bbdd1">cp</a></td></tr>
<tr class="memdesc:a5ea8e096eeff4452f59443d6cb9bbdd1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Specular reflectance vector for this material.  <a href="#a5ea8e096eeff4452f59443d6cb9bbdd1">More...</a><br /></td></tr>
<tr class="separator:a5ea8e096eeff4452f59443d6cb9bbdd1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af3007a6aa76a2e6f23778ed5394cf2f7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#af3007a6aa76a2e6f23778ed5394cf2f7">ca</a></td></tr>
<tr class="memdesc:af3007a6aa76a2e6f23778ed5394cf2f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Ambient light vector.  <a href="#af3007a6aa76a2e6f23778ed5394cf2f7">More...</a><br /></td></tr>
<tr class="separator:af3007a6aa76a2e6f23778ed5394cf2f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab25e134eb2853b9d1207bf4b9163aa1a"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#ab25e134eb2853b9d1207bf4b9163aa1a">p</a></td></tr>
<tr class="memdesc:ab25e134eb2853b9d1207bf4b9163aa1a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Phong exponent for this material.  <a href="#ab25e134eb2853b9d1207bf4b9163aa1a">More...</a><br /></td></tr>
<tr class="separator:ab25e134eb2853b9d1207bf4b9163aa1a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a133e528e69badb73022248d69f74e6bb"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a133e528e69badb73022248d69f74e6bb">emissive</a></td></tr>
<tr class="memdesc:a133e528e69badb73022248d69f74e6bb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating whether this material is to be emissive and, if so, _cr will be used to define what is emitted (instead, the emission is controlled by the texture mapping if param _filename is not NULL)  <a href="#a133e528e69badb73022248d69f74e6bb">More...</a><br /></td></tr>
<tr class="separator:a133e528e69badb73022248d69f74e6bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3dbb2d757ff62d77db78e02d3d1eca7d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a3dbb2d757ff62d77db78e02d3d1eca7d">bump</a></td></tr>
<tr class="memdesc:a3dbb2d757ff62d77db78e02d3d1eca7d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating whether this material is to be bump mapped.  <a href="#a3dbb2d757ff62d77db78e02d3d1eca7d">More...</a><br /></td></tr>
<tr class="separator:a3dbb2d757ff62d77db78e02d3d1eca7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9546ff9da82a0f7de667d3f9f1ee3fe"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#ae9546ff9da82a0f7de667d3f9f1ee3fe">tiling</a></td></tr>
<tr class="memdesc:ae9546ff9da82a0f7de667d3f9f1ee3fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of times the texture is to be replicated.  <a href="#ae9546ff9da82a0f7de667d3f9f1ee3fe">More...</a><br /></td></tr>
<tr class="separator:ae9546ff9da82a0f7de667d3f9f1ee3fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa888d8c2af8d3e4b83c84b5bf1a7a44f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#aa888d8c2af8d3e4b83c84b5bf1a7a44f">tex_map</a></td></tr>
<tr class="memdesc:aa888d8c2af8d3e4b83c84b5bf1a7a44f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating whether this material is associated to a texture map.  <a href="#aa888d8c2af8d3e4b83c84b5bf1a7a44f">More...</a><br /></td></tr>
<tr class="separator:aa888d8c2af8d3e4b83c84b5bf1a7a44f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a396bd4e93971db0e58297864217038b4"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a396bd4e93971db0e58297864217038b4">reflective</a></td></tr>
<tr class="memdesc:a396bd4e93971db0e58297864217038b4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating whether this material is to be reflective, i.e., mirror-like.  <a href="#a396bd4e93971db0e58297864217038b4">More...</a><br /></td></tr>
<tr class="separator:a396bd4e93971db0e58297864217038b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9af8008c4823e80a06e541f9e4813f7d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a9af8008c4823e80a06e541f9e4813f7d">refractive</a></td></tr>
<tr class="memdesc:a9af8008c4823e80a06e541f9e4813f7d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating whether this material is to be a dieletric, i.e., if it both reflects and refracts light.  <a href="#a9af8008c4823e80a06e541f9e4813f7d">More...</a><br /></td></tr>
<tr class="separator:a9af8008c4823e80a06e541f9e4813f7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae87327bf313e3ba962250e6bc330f990"><td class="memItemLeft" align="right" valign="top">double *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#ae87327bf313e3ba962250e6bc330f990">tex_image</a></td></tr>
<tr class="memdesc:ae87327bf313e3ba962250e6bc330f990"><td class="mdescLeft">&#160;</td><td class="mdescRight">Texture image used for texture mapping.  <a href="#ae87327bf313e3ba962250e6bc330f990">More...</a><br /></td></tr>
<tr class="separator:ae87327bf313e3ba962250e6bc330f990"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b59cfd4617315821575ad1ad8752a7d"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a0b59cfd4617315821575ad1ad8752a7d">decay</a></td></tr>
<tr class="separator:a0b59cfd4617315821575ad1ad8752a7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9fccedcfa4d38d3b36f8c09a48811213"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a9fccedcfa4d38d3b36f8c09a48811213">rft</a></td></tr>
<tr class="separator:a9fccedcfa4d38d3b36f8c09a48811213"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8dc3db8a8b55b6709017d953e8e6ce8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#ae8dc3db8a8b55b6709017d953e8e6ce8">tex_width</a></td></tr>
<tr class="memdesc:ae8dc3db8a8b55b6709017d953e8e6ce8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Width, in pixels, of the texture image loaded for texture mapping.  <a href="#ae8dc3db8a8b55b6709017d953e8e6ce8">More...</a><br /></td></tr>
<tr class="separator:ae8dc3db8a8b55b6709017d953e8e6ce8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64903bf3624a095b95004620cc4c3688"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#a64903bf3624a095b95004620cc4c3688">tex_height</a></td></tr>
<tr class="memdesc:a64903bf3624a095b95004620cc4c3688"><td class="mdescLeft">&#160;</td><td class="mdescRight">Height, in pixels, of the texture image loaded for texture mapping.  <a href="#a64903bf3624a095b95004620cc4c3688">More...</a><br /></td></tr>
<tr class="separator:a64903bf3624a095b95004620cc4c3688"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba2f3bbc30230e5d6dc7376b6e88df72"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_material.html#aba2f3bbc30230e5d6dc7376b6e88df72">k</a></td></tr>
<tr class="separator:aba2f3bbc30230e5d6dc7376b6e88df72"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to create and manipulate surface materials. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aa798c4ee73c9078a8c5c23fee3edebae"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa798c4ee73c9078a8c5c23fee3edebae">&sect;&nbsp;</a></span>Material() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Material::Material </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_cr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_cp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_ca</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_decay</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_rft</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_emissive</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_refl</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_refr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_bump</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>_filename</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_cr</td><td>Diffuse reflectance vector for this material </td></tr>
    <tr><td class="paramname">_cp</td><td>Specular reflectance vector for this material </td></tr>
    <tr><td class="paramname">_ca</td><td>Ambient light vector </td></tr>
    <tr><td class="paramname">_p</td><td>Phong exponent for this material </td></tr>
    <tr><td class="paramname">_decay</td><td>Proportion of the incident light to be absorbed by this material, when defined as reflective (_refl = true) </td></tr>
    <tr><td class="paramname">_rft</td><td>Refraction index for this material (only relevant if _refr = true) </td></tr>
    <tr><td class="paramname">_emissive</td><td>Flag stating whether this material is to be emissive and, if so, _cr will be used to define what is emitted (instead, the emission is controlled by the texture mapping if param _filename is not NULL) </td></tr>
    <tr><td class="paramname">_refl</td><td>Flag stating whether this material is to be reflective, i.e., mirror-like </td></tr>
    <tr><td class="paramname">_refr</td><td>Flag stating whether this material is to be a dieletric, i.e., if it both reflects and refracts light </td></tr>
    <tr><td class="paramname">_bump</td><td>Flag stating whether this material is to be bump mapped </td></tr>
    <tr><td class="paramname">_filename</td><td>path to a .ppm file to be used for mapping a texture to this material (use NULL is no texture mapping if to be used) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a137e987401b63eb7c6c27c3e38bc74b5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a137e987401b63eb7c6c27c3e38bc74b5">&sect;&nbsp;</a></span>Material() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Material::Material </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a2c19452d71f54075df8f5405b03129f4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2c19452d71f54075df8f5405b03129f4">&sect;&nbsp;</a></span>~Material()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Material::~Material </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aa01fadeeceee9591a552c3688db5a533"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa01fadeeceee9591a552c3688db5a533">&sect;&nbsp;</a></span>getCa()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Material::getCa </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the ambient light vector for this material. </p>
<dl class="section return"><dt>Returns</dt><dd>The ambient light vector for this material. </dd></dl>

</div>
</div>
<a id="ad07aff294522f7d3c0d453627bd364fd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad07aff294522f7d3c0d453627bd364fd">&sect;&nbsp;</a></span>getCp()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Material::getCp </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the specular reflectance vector for this material. </p>
<dl class="section return"><dt>Returns</dt><dd>The specular reflectance vector for this material. </dd></dl>

</div>
</div>
<a id="a0280b01366a8f0fc2ffdeb87ac0fd275"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0280b01366a8f0fc2ffdeb87ac0fd275">&sect;&nbsp;</a></span>getCr()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Material::getCr </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the diffuse reflectance vector for this material. </p>
<dl class="section return"><dt>Returns</dt><dd>The diffuse reflectance vector for this material. </dd></dl>

</div>
</div>
<a id="abbbad91a1d220c635894891ab71d6563"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abbbad91a1d220c635894891ab71d6563">&sect;&nbsp;</a></span>getLightDecay()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double Material::getLightDecay </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Returns the proportion of the incident light to be absorbed by this material, when defined as reflective/refractive Values &lt; 1 results in light decay. Values &gt; 1 results in light amplification.</p>
<dl class="section return"><dt>Returns</dt><dd>The proportion of the incident light to be absorbed by this material. </dd></dl>

</div>
</div>
<a id="a65f9dd5151b513f5bcf54a5fd59b15f2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a65f9dd5151b513f5bcf54a5fd59b15f2">&sect;&nbsp;</a></span>getPhong()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double Material::getPhong </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the Phong exponent for this material. </p>
<dl class="section return"><dt>Returns</dt><dd>The Phong exponent for this material. </dd></dl>

</div>
</div>
<a id="acbacd01f9d2f985ede123b91687280e8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acbacd01f9d2f985ede123b91687280e8">&sect;&nbsp;</a></span>getRefractiveIndex()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double Material::getRefractiveIndex </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the refractive index of this material. </p>
<dl class="section return"><dt>Returns</dt><dd>The refractive index of this material. </dd></dl>

</div>
</div>
<a id="a6db84f732fc3c38423cbbec8d15e52cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6db84f732fc3c38423cbbec8d15e52cb">&sect;&nbsp;</a></span>getTilesNumber()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int Material::getTilesNumber </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the number of times the texture is to be replicated in each direction. </p>
<dl class="section return"><dt>Returns</dt><dd>The the number of times the texture is to be replicated in each direction. </dd></dl>

</div>
</div>
<a id="a9456e7bde8f91663bb7bae200877e45a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9456e7bde8f91663bb7bae200877e45a">&sect;&nbsp;</a></span>isBumpMapped()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::isBumpMapped </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a boolean stating whether this is a bump mapped material. </p>
<dl class="section return"><dt>Returns</dt><dd>A boolean stating whether this is a bump mapped material. </dd></dl>

</div>
</div>
<a id="a6175de849601404346db9607b44986dd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6175de849601404346db9607b44986dd">&sect;&nbsp;</a></span>isEmissive()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::isEmissive </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a boolean stating whether this is an emissive material. </p>
<dl class="section return"><dt>Returns</dt><dd>A boolean stating whether this is an emissive material. </dd></dl>

</div>
</div>
<a id="a4d14399b390d6795965b51ae9f51e9f4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4d14399b390d6795965b51ae9f51e9f4">&sect;&nbsp;</a></span>isReflective()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::isReflective </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a boolean stating whether this is a reflective material. </p>
<dl class="section return"><dt>Returns</dt><dd>A boolean stating whether this is a reflective material. </dd></dl>

</div>
</div>
<a id="ad7ca9400c928202eaca2082e291125b1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad7ca9400c928202eaca2082e291125b1">&sect;&nbsp;</a></span>isRefractive()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::isRefractive </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a boolean stating whether this is a refractive material. </p>
<dl class="section return"><dt>Returns</dt><dd>A boolean stating whether this is a refractive material. </dd></dl>

</div>
</div>
<a id="a6f2ba344ff230ccb271f60968af8b0e1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6f2ba344ff230ccb271f60968af8b0e1">&sect;&nbsp;</a></span>isTextureMapped()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::isTextureMapped </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a boolean stating whether this is a textured mapped material. </p>
<dl class="section return"><dt>Returns</dt><dd>A boolean stating whether this is a textured mapped material. </dd></dl>

</div>
</div>
<a id="a7ec5589e2e78d79fa32c25ee00a3b824"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7ec5589e2e78d79fa32c25ee00a3b824">&sect;&nbsp;</a></span>loadPPM()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double * Material::loadPPM </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Loads a texture from a .ppm file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>The name of the texture .ppm file (including complete path). </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A buffer containing the loaded texture. </dd></dl>

</div>
</div>
<a id="ab1a8ca07450c105b312f501db03d9ded"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab1a8ca07450c105b312f501db03d9ded">&sect;&nbsp;</a></span>setBumpMapped()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setBumpMapped </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_bump</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets a boolean stating whether this is a bump mapped material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_bump</td><td>A boolean stating whether this is a bump mapped material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aeee8f14c34749e8d299ca6e43858a840"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeee8f14c34749e8d299ca6e43858a840">&sect;&nbsp;</a></span>setCa()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setCa </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_ca</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the ambient light vector for this material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_ca</td><td>The ambient light vector for this material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a8e1ec1391572fc46164d392f07129174"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8e1ec1391572fc46164d392f07129174">&sect;&nbsp;</a></span>setCp()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setCp </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_cp</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the specular reflectance vector for this material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_cp</td><td>The specular reflectance vector for this material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a847f683a1b2f97d6a7ee182c9e87eca3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a847f683a1b2f97d6a7ee182c9e87eca3">&sect;&nbsp;</a></span>setCr()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setCr </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_cr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the diffuse reflectance vector for this material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_cr</td><td>The diffuse reflectance vector for this material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a782130f7a711c6607dcfe6124a82469f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a782130f7a711c6607dcfe6124a82469f">&sect;&nbsp;</a></span>setEmissive()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setEmissive </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_emissive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets a boolean stating whether this is an emissive material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_emissive</td><td>A boolean stating whether this is an emissive material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae52779c037c246aceac07f2d14fb92a8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae52779c037c246aceac07f2d14fb92a8">&sect;&nbsp;</a></span>setLightDecay()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setLightDecay </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_decay</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Sets the proportion of the incident light to be absorbed by this material, when defined as reflective/refractive Values &lt; 1 results in light decay. Values &gt; 1 results in light amplification.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_decay</td><td>The proportion of the incident light to be absorbed by this material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a61bbfad1e60d4e41943972774d0bc067"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a61bbfad1e60d4e41943972774d0bc067">&sect;&nbsp;</a></span>setPhong()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setPhong </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_p</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the Phong exponent for this material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_p</td><td>The Phong exponent for this material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a7b442ea5f27bc51da4822e02fb4297bb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7b442ea5f27bc51da4822e02fb4297bb">&sect;&nbsp;</a></span>setReflective()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setReflective </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_reflective</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets a boolean stating whether this is a reflective material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_reflective</td><td>A boolean stating whether this is a reflective material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="adff5906d2e02f7191d6827f093789780"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adff5906d2e02f7191d6827f093789780">&sect;&nbsp;</a></span>setRefractive()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setRefractive </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_refractive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets a boolean stating whether this is a refractive material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_refractive</td><td>A boolean stating whether this is a refractive material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a114906601db621c0d7101961300d8308"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a114906601db621c0d7101961300d8308">&sect;&nbsp;</a></span>setRefractiveIndex()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setRefractiveIndex </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_rft</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the refractive index of this material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_rft</td><td>The refractive index of this material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a938b386ff83eb1cde4831c0c36a5407e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a938b386ff83eb1cde4831c0c36a5407e">&sect;&nbsp;</a></span>setTextureMapped()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setTextureMapped </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_tex_map</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets a boolean stating whether this is a textured mapped material. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_tex_map</td><td>A boolean stating whether this is a textured mapped material. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae9a0316f3ea807c95d1b3d347bfd7dc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae9a0316f3ea807c95d1b3d347bfd7dc0">&sect;&nbsp;</a></span>setTilesNumber()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Material::setTilesNumber </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_tiling</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the number of times the texture is to be replicated in each direction. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_tiling</td><td>The the number of times the texture is to be replicated in each direction. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="afbe529757a43277bb1d1a65c42741e68"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afbe529757a43277bb1d1a65c42741e68">&sect;&nbsp;</a></span>tex_pixel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Material::tex_pixel </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>tex_coord</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the colour Vector obtained from the texture, given a 2D texture coordinate. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">tex_coord</td><td>A 2D texture coordinate; </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The colour of the pixel at tex_coord in the texture image. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a3dbb2d757ff62d77db78e02d3d1eca7d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3dbb2d757ff62d77db78e02d3d1eca7d">&sect;&nbsp;</a></span>bump</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::bump</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag stating whether this material is to be bump mapped. </p>

</div>
</div>
<a id="af3007a6aa76a2e6f23778ed5394cf2f7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af3007a6aa76a2e6f23778ed5394cf2f7">&sect;&nbsp;</a></span>ca</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Material::ca</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Ambient light vector. </p>

</div>
</div>
<a id="a5ea8e096eeff4452f59443d6cb9bbdd1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5ea8e096eeff4452f59443d6cb9bbdd1">&sect;&nbsp;</a></span>cp</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Material::cp</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Specular reflectance vector for this material. </p>

</div>
</div>
<a id="a6b14d96290f6529241d9b898596b83c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6b14d96290f6529241d9b898596b83c5">&sect;&nbsp;</a></span>cr</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Material::cr</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Diffuse reflectance vector for this material. </p>

</div>
</div>
<a id="a0b59cfd4617315821575ad1ad8752a7d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0b59cfd4617315821575ad1ad8752a7d">&sect;&nbsp;</a></span>decay</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Material::decay</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Proportion of the incident light to be absorbed by this material, when defined as reflective/refractive Values &lt; 1 results in light decay. Values &gt; 1 results in light amplification. </p>

</div>
</div>
<a id="a133e528e69badb73022248d69f74e6bb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a133e528e69badb73022248d69f74e6bb">&sect;&nbsp;</a></span>emissive</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::emissive</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag stating whether this material is to be emissive and, if so, _cr will be used to define what is emitted (instead, the emission is controlled by the texture mapping if param _filename is not NULL) </p>

</div>
</div>
<a id="aba2f3bbc30230e5d6dc7376b6e88df72"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aba2f3bbc30230e5d6dc7376b6e88df72">&sect;&nbsp;</a></span>k</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Material::k</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ab25e134eb2853b9d1207bf4b9163aa1a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab25e134eb2853b9d1207bf4b9163aa1a">&sect;&nbsp;</a></span>p</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Material::p</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Phong exponent for this material. </p>

</div>
</div>
<a id="a396bd4e93971db0e58297864217038b4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a396bd4e93971db0e58297864217038b4">&sect;&nbsp;</a></span>reflective</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::reflective</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag stating whether this material is to be reflective, i.e., mirror-like. </p>

</div>
</div>
<a id="a9af8008c4823e80a06e541f9e4813f7d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9af8008c4823e80a06e541f9e4813f7d">&sect;&nbsp;</a></span>refractive</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::refractive</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag stating whether this material is to be a dieletric, i.e., if it both reflects and refracts light. </p>

</div>
</div>
<a id="a9fccedcfa4d38d3b36f8c09a48811213"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9fccedcfa4d38d3b36f8c09a48811213">&sect;&nbsp;</a></span>rft</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Material::rft</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Refractive index for this material (only relevant if _refr = true). To save computation, if the value is exactly 1, the renderer will not cast a secondary reflection ray (only the refraction ray will be cast). </p>

</div>
</div>
<a id="a64903bf3624a095b95004620cc4c3688"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a64903bf3624a095b95004620cc4c3688">&sect;&nbsp;</a></span>tex_height</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Material::tex_height</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Height, in pixels, of the texture image loaded for texture mapping. </p>

</div>
</div>
<a id="ae87327bf313e3ba962250e6bc330f990"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae87327bf313e3ba962250e6bc330f990">&sect;&nbsp;</a></span>tex_image</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double* Material::tex_image</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Texture image used for texture mapping. </p>

</div>
</div>
<a id="aa888d8c2af8d3e4b83c84b5bf1a7a44f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa888d8c2af8d3e4b83c84b5bf1a7a44f">&sect;&nbsp;</a></span>tex_map</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Material::tex_map</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag stating whether this material is associated to a texture map. </p>

</div>
</div>
<a id="ae8dc3db8a8b55b6709017d953e8e6ce8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae8dc3db8a8b55b6709017d953e8e6ce8">&sect;&nbsp;</a></span>tex_width</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Material::tex_width</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Width, in pixels, of the texture image loaded for texture mapping. </p>

</div>
</div>
<a id="ae9546ff9da82a0f7de667d3f9f1ee3fe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae9546ff9da82a0f7de667d3f9f1ee3fe">&sect;&nbsp;</a></span>tiling</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Material::tiling</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Number of times the texture is to be replicated. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="_material_8hpp_source.html">Material.hpp</a></li>
<li>src/<a class="el" href="_material_8cpp.html">Material.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_material.html">Material</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
